LeetCode 930 - Binary Subarrays With Sum


https://leetcode.com/problems/binary-subarrays-with-sum/
In an array A of 0s and 1s, how many non-empty subarrays have sum S?

Example 1:
Input: A = [1,0,1,0,1], S = 2
Output: 4
Explanation: 
The 4 subarrays are bolded below:
[1,0,1,0,1]
[1,0,1,0,1]
[1,0,1,0,1]
[1,0,1,0,1]
Approach 3: Three Pointer
For each j, let's try to count the number of i's that have the subarray [i, j] equal to S.
It is easy to see these i's form an interval [i_lo, i_hi], and each of i_loi_hi are increasing with respect to j. So we can use a "two pointer" style approach.
Algorithm
For each j (in increasing order), let's maintain 4 variables:
  • sum_lo : the sum of subarray [i_lo, j]
  • sum_hi : the sum of subarray [i_hi, j]
  • i_lo : the smallest i so that sum_lo <= S
  • i_hi : the largest i so that sum_hi <= S
Then, (provided that sum_lo == S), the number of subarrays ending in j is i_hi - i_lo + 1.
As an example, with A = [1,0,0,1,0,1] and S = 2, when j = 5, we want i_lo = 1 and i_hi = 3.
  public int numSubarraysWithSum(int[] A, int S) {
    int iLo = 0, iHi = 0;
    int sumLo = 0, sumHi = 0;
    int ans = 0;

    for (int j = 0; j < A.length; ++j) {
      // While sumLo is too big, iLo++
      sumLo += A[j];
      while (iLo < j && sumLo > S)
        sumLo -= A[iLo++];

      // While sumHi is too big, or equal and we can move, iHi++
      sumHi += A[j];
      while (iHi < j && (sumHi > S || sumHi == S && A[iHi] == 0))
        sumHi -= A[iHi++];

      if (sumLo == S)
        ans += iHi - iLo + 1;
    }

    return ans;
  }


Approach 2: Prefix Sums

Intuition
Let P[i] = A[0] + A[1] + ... + A[i-1]. Then P[j+1] - P[i] = A[i] + A[i+1] + ... + A[j], the sum of the subarray [i, j].
Hence, we are looking for the number of i < j with P[j] - P[i] = S.
Algorithm
For each j, let's count the number of i with P[j] = P[i] + S. This is analogous to counting the number of subarrays ending in j with sum S.
It comes down to counting how many P[i] + S we've seen before. We can keep this count on the side to help us find the final answer.
  public int numSubarraysWithSum(int[] A, int S) {
    int N = A.length;
    int[] P = new int[N + 1];
    for (int i = 0; i < N; ++i)
      P[i + 1] = P[i] + A[i];

    Map<Integer, Integer> count = new HashMap();
    int ans = 0;
    for (int x : P) {
      ans += count.getOrDefault(x, 0);
      count.put(x + S, count.getOrDefault(x + S, 0) + 1);
    }

    return ans;
  }
https://leetcode.com/problems/binary-subarrays-with-sum/discuss/186683/C%2B%2BJavaPython-Straight-Forward
    public int numSubarraysWithSum(int[] A, int S) {
        int psum = 0, res = 0, count[] = new int[A.length + 1];
        count[0] = 1;
        for (int i : A) {
            psum += i;
            if (psum >= S)
                res += count[psum - S];
            count[psum]++;
        }
        return res;
    }
https://leetcode.com/problems/binary-subarrays-with-sum/discuss/186647/Java-Clean-Solution-2-Sum-%2B-Prefix-Sum-Caching
Using a hashmap is overkill in this problem since the only sums that are possible are [0, 1, ..., n].
Therefore, we can just an array as our map instread. Credits to @davidluoyes for pointing this out.
    public int numSubarraysWithSum(int[] A, int target) {
        //The largest sum we can have is len(A) = n Why? What if array A[] has all 1's.
        int n = A.length;
        //Everything is initialized to zero
        int[] presum = new int[n+1];
        int sum = 0;
        //Case where it's just it's own 
        int total = 0;
        
        for (int i = 0; i < A.length; i++){
            sum += A[i];
            int compliment = sum - target;
            
            if (compliment >= 0)
            total += presum[compliment];
            
            if (sum == target) total++;
            //Also put this sum into the map as well
            presum[sum]+=1;
        }
        
        return total;
        
    }
TLDR; Two Sum + Prefix Sum Caching
Logic: In this problem we are required to find some interval [i:j] ,i < j where sum[i:j] = target. We know that sum[i:j] = A[i] + A[i+1] +... + A[j].
Then we also know that
Let's define prefixSum[j] = A[0] + A[1] + ... + A[j] 0 <= j <= n-1 (n = A.length)
It is easy to see that,
sum[i:j] = A[i] + A[i+1] ... + A[j] =
(A[0] + A[1] + ... A[i] ... + A[j]) - (A[0] + A[1] + ... A[i-1]) =
prefix[j] - prefix[i-1].
Now we the problem reduces to finding # of pairs (i, j) (i < j) such that
prefix[j] - prefix[i-1] = target
This becomes prefix[i-1] = prefix[j] - target with some algebra.
So we use the hashmap to find all pairs that satisfy the above equations.
We only need to track the prefix sum up to this point however, since we already saved all the previous results in the map.
if (sum == target) total++ Here I am checking for the case where the current element is equal to the sum (it needs no interval to produce the sum).
    public int numSubarraysWithSum(int[] A, int target) {
        Map<Integer, Integer> presum = new HashMap<>();
 //Prefix sum
        int sum = 0;
 //Answer
        int total = 0;
        for (int i = 0; i < A.length; i++){
            sum += A[i];
            if (presum.get(sum - target) != null){
                total += presum.get(sum - target);
            }
            if (sum == target) total++;
            //Also put this sum into the map as well
            presum.put(sum, presum.getOrDefault(sum, 0) + 1);
        }
        
        return total;
        
    }




Approach 1: Index of Ones

Intuition
Say we number the 1s in A(x_1, x_2, \cdots, x_n) with A[x_i] = 1.
Then, if we have a subarray of sum S, it has to use the ones x_i, x_{i+1}, \cdots, x_{i+S-1}. For each i, we can count the number of such subarrays individually.
Algorithm
In general, the number of such subarrays (for i) is (x_i - x_{i-1}) * (x_{i+S} - x_{i+S-1}).
For example, if S = 2, then in A = [1,0,1,0,1,0,0,1], let's count the number of subarrays [i, j] that use the middle two 1s. There are 2 choices for the i (i = 1, 2) and 3 choices for the j (j = 4, 5, 6).
The corner cases are when S = 0i = 1, or i+S = n+1. We can handle these gracefully.
public int numSubarraysWithSum(int[] A, int S) {
int su = 0;
for (int x : A)
su += x;

// indexes[i] = location of i-th one (1 indexed)
int[] indexes = new int[su + 2];
int t = 0;
indexes[t++] = -1;
for (int i = 0; i < A.length; ++i)
if (A[i] == 1)
indexes[t++] = i;
indexes[t] = A.length;

int ans = 0;
if (S == 0) {
for (int i = 0; i < indexes.length - 1; ++i) {
// w: number of zeros between consecutive ones
int w = indexes[i + 1] - indexes[i] - 1;
ans += w * (w + 1) / 2;
}
return ans;
}

for (int i = 1; i < indexes.length - S; ++i) {
int j = i + S - 1;
int left = indexes[i] - indexes[i - 1];
int right = indexes[j + 1] - indexes[j];
ans += left * right;
}

return ans;
}

This problem is a simplified problem of 560. This is the link.
  1. brute force: $Time: O(N^2), Space: O(1)$
    loop all [i, j] combination.
  2. presum $Time: O(N), Space: O(N)$
    store previous sum and the times of this sum, because sum[i, j] = sum[0, j] - sum[0, i - 1], this is a very very important idea
  3. two pointer: (positive value)
    if there no 0, we can use 2 pointers easily to solve this problem, because the right pointer moving forward makes the sum larger, and left pointer moving forward makes the sum smaller.
    BUT, if there exists 0, we need to pay attention to pattern like this :
    [x,x,x,0,0,0,y,y,y,0,0,0,z,z,z], assuming that y+y+y in the mediumm is what we want, so when lo is the idx of the first y, and hi is the idx of the last y, now prev is the idx of the last x, which is the closest non-0 to the first y(A[lo]), then we can know that up to hi, we have 1 + (lo - prev - 1) subarrays satisfying the sum equals K. This in java likes this:
if ( sum + A[hi] == K ) {
    sum += A[hi];
    hi++;
    cnt += 1 + (lo - prev - 1);
}
There are two more branches to consider, one is that sum + A[hi] is smaller than K, which we need to move hi forward to make sum bigger. This in java likes this:
if ( sum + A[hi] < K ) {
    sum += A[hi];
    hi++;
}
the other one is that sum + A[hi] is bigger than K, which we need to move lo forward to make sum smaller, BUT, there are one more condition we need to pay attention to, that is when we move forward, we need to update current prev to the preivous lo. And to make sure A[lo] is non-0, we need to move lo over the 0 in [y,y,y]. This in java likes this:
if ( sum + A[hi] > K ) {
    sum -= A[lo];
    prev = lo;
    lo++;
    while ( A[lo] == 0 ) {
        lo++;
    }
}
So now we have the code like this:
if ( sum + A[hi] == K ) {
    sum += A[hi];
    hi++;
    cnt += 1 + (lo - prev - 1);
}
else if ( sum + A[hi] < K ) {
    sum += A[hi];
    hi++;
}
else {
    sum -= A[hi];
    prev = lo;
    lo++;
    while ( A[lo] == 0 ) {
        lo++;
    }
}
And also we need to pay attention to S = 0. And case like [0,0,0,0,0] S > 0. So the whole code is as follows:
public int numSubarraysWithSum(int[] A, int S) {
    if ( S == 0 ) return helper(A); //deal with S == 0 
    int prev = -1;
    int lo = 0, hi = 0;
    int sum = 0;
    int cnt = 0;
    // deal with S > 0 but cases like[0,0,0,0,0]
    while ( lo < A.length && A[lo] == 0 ) {
        lo++;
        hi++;
    }
    while ( hi < A.length ) {
        if ( sum + A[hi] == S ) {
            sum += A[hi];
            cnt += 1 + (lo - prev - 1);
            hi++;
        }
        else if ( sum + A[hi] < S ) {
            sum += A[hi];
            hi++;
        }
        else {
            sum -= A[lo];
            prev = lo;
            lo++;
            while ( A[lo] == 0 ) 
                lo++;
        }
    }
    return cnt;
}
public int helper(int[] A) {
    int cnt = 0;
    int res = 0;
    for ( int i = 0; i < A.length; i++ ) {
        if ( A[i] == 0 ) {
            cnt++;
            res += cnt;
        }
        else {
            cnt = 0;
        }
    }
    return res;
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts